﻿using System.Drawing;

namespace TestProject
{
    /// <summary>
    /// 문서 옵션
    /// </summary>
    public class DocumentOption
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 왼쪽 도킹 허용 여부
        /// </summary>
        private bool allowDockLeft = true;

        /// <summary>
        /// 위쪽 도킹 허용 여부
        /// </summary>
        private bool allowDockTop = true;

        /// <summary>
        /// 오른쪽 도킹 허용 여부
        /// </summary>
        private bool allowDockRight = true;

        /// <summary>
        /// 아래쪽 도킹 허용 여부
        /// </summary>
        private bool allowDockBottom = true;

        /// <summary>
        /// 채우기 도킹 허용 여부
        /// </summary>
        private bool allowDockFill = true;

        /// <summary>
        /// 플로팅 허용 여부
        /// </summary>
        private bool allowFloating = true;

        /// <summary>
        /// 더블 클릭시 플로팅 여부
        /// </summary>
        private bool floatOnDblClick = true;

        /// <summary>
        /// 자동 숨김 버튼 표시 여부
        /// </summary>
        private bool showAutoHideButton = true;

        /// <summary>
        /// 최대화 버튼 표시 여부
        /// </summary>
        private bool showMaximizeButton = true;

        /// <summary>
        /// 닫기 버튼 표시 여부
        /// </summary>
        private bool showCloseButton = true;

        /// <summary>
        /// 플로팅 위치
        /// </summary>
        private Point? floatLocation = null;

        /// <summary>
        /// 플로팅 크기
        /// </summary>
        private Size? floatSize = null;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 왼쪽 도킹 허용 여부 - AllowDockLeft

        /// <summary>
        /// 왼쪽 도킹 허용 여부
        /// </summary>
        public bool AllowDockLeft
        {
            get
            {
                return this.allowDockLeft;
            }
            set
            {
                this.allowDockLeft = value;
            }
        }

        #endregion
        #region 위쪽 도킹 허용 여부 - AllowDockTop

        /// <summary>
        /// 위쪽 도킹 허용 여부
        /// </summary>
        public bool AllowDockTop
        {
            get
            {
                return this.allowDockTop;
            }
            set
            {
                this.allowDockTop = value;
            }
        }

        #endregion
        #region 오른쪽 도킹 허용 여부 - AllowDockRight

        /// <summary>
        /// 오른쪽 도킹 허용 여부
        /// </summary>
        public bool AllowDockRight
        {
            get
            {
                return this.allowDockRight;
            }
            set
            {
                this.allowDockRight = value;
            }
        }

        #endregion
        #region 아래쪽 도킹 허용 여부 - AllowDockBottom

        /// <summary>
        /// 아래쪽 도킹 허용 여부
        /// </summary>
        public bool AllowDockBottom
        {
            get
            {
                return this.allowDockBottom;
            }
            set
            {
                this.allowDockBottom = value;
            }
        }

        #endregion
        #region 채우기 도킹 허용 여부 - AllowDockFill

        /// <summary>
        /// 채우기 도킹 허용 여부
        /// </summary>
        public bool AllowDockFill
        {
            get
            {
                return this.allowDockFill;
            }
            set
            {
                this.allowDockFill = value;
            }
        }

        #endregion
        #region 플로팅 허용 여부 - AllowFloating

        /// <summary>
        /// 플로팅 허용 여부
        /// </summary>
        public bool AllowFloating
        {
            get
            {
                return this.allowFloating;
            }
            set
            {
                this.allowFloating = value;
            }
        }

        #endregion
        #region 더블 클릭시 플로팅 여부 - FloatOnDblClick

        /// <summary>
        /// 더블 클릭시 플로팅 여부
        /// </summary>
        public bool FloatOnDblClick
        {
            get
            {
                return this.floatOnDblClick;
            }
            set
            {
                this.floatOnDblClick = value;
            }
        }
        #endregion
        #region 자동 숨김 버튼 표시 여부 - ShowAutoHideButton

        /// <summary>
        /// 자동 숨김 버튼 표시 여부
        /// </summary>
        public bool ShowAutoHideButton
        {
            get
            {
                return this.showAutoHideButton;
            }
            set
            {
                this.showAutoHideButton = value;
            }
        }

        #endregion
        #region 최대화 버튼 표시 여부 - ShowMaximizeButton

        /// <summary>
        /// 최대화 버튼 표시 여부
        /// </summary>
        public bool ShowMaximizeButton
        {
            get
            {
                return this.showMaximizeButton;
            }
            set
            {
                this.showMaximizeButton = value;
            }
        }

        #endregion
        #region 닫기 버튼 표시 여부 - ShowCloseButton

        /// <summary>
        /// 닫기 버튼 표시 여부
        /// </summary>
        public bool ShowCloseButton
        {
            get
            {
                return this.showCloseButton;
            }
            set
            {
                this.showCloseButton = value;
            }
        }

        #endregion
        #region 플로팅 위치 - FloatLocation

        /// <summary>
        /// 플로팅 위치
        /// </summary>
        public Point? FloatLocation
        {
            get
            {
                return this.floatLocation;
            }
            set
            {
                this.floatLocation = value;
            }
        }

        #endregion
        #region 플로팅 크기 - FloatSize

        /// <summary>
        /// 플로팅 크기
        /// </summary>
        public Size? FloatSize
        {
            get
            {
                return this.floatSize;
            }
            set
            {
                this.floatSize = value;
            }
        }

        #endregion
    }
}