﻿using System;
using System.Drawing;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 카운트
        /// </summary>
        private int count = 1;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            this.addDocumentButton1.Click += addDocumentButton1_Click;
            this.addDocumentButton2.Click += addDocumentButton2_Click;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region 문서 추가 버튼 1 클릭시 처리하기 - addDocumentButton1_Click(sender, e)

        /// <summary>
        /// 문서 추가 버튼 1 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void addDocumentButton1_Click(object sender, EventArgs e)
        {
            string name = "panel" + this.count.ToString();
            string text = "Panel" + this.count.ToString();

            this.count++;

            //////////////////////////////////////// CONTENT CONTROL START
            Button button = new Button();

            button.Name     = "testButton";
            button.Text     = "TEST";
            button.Size     = new Size(100, 25);
            button.Location = new Point(50, 50);
            //////////////////////////////////////// CONTENT CONTROL END

            DocumentOption documentOption = new DocumentOption();

            documentOption.AllowDockFill = false;

            this.firstDocumentControl.AddDocument(name, text, button, documentOption);
        }

        #endregion
        #region 문서 추가 버튼 2 클릭시 처리하기 - addDocumentButton2_Click(sender, e)

        /// <summary>
        /// 문서 추가 버튼 2 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void addDocumentButton2_Click(object sender, EventArgs e)
        {
            string name = "panel" + this.count.ToString();
            string text = "Panel" + this.count.ToString();

            this.count++;

            //////////////////////////////////////// CONTENT CONTROL START
            ComboBox comboBox = new ComboBox();

            comboBox.Name     = "testComboBox";
            comboBox.Text     = "TEST";
            comboBox.Size     = new Size(100, 25);
            comboBox.Location = new Point(50, 50);
            //////////////////////////////////////// CONTENT CONTROL END

            this.secondDocumentControl.AddDocument(name, text, comboBox);
        }

        #endregion
    }
}